/*
 * XmlParserAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_PARSER_ABSTRACTION_HPP_
#define _XML_PARSER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <exception/CommonException.h>
#include <factory/XmlDataFactory.hpp>

namespace abstraction {

template < class ReturnType >
class XmlParserAbstraction : public UnaryOperationAbstraction < ReturnType, ext::deque < sax::Token > && > {

public:
	bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->getParams ( ) );
		this->setData ( factory::XmlDataFactory::fromTokens ( abstraction::retrieveValue < ext::deque < sax::Token > && > ( param.first, param.second ) ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_PARSER_ABSTRACTION_HPP_ */
